<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" import="fr.cirad.tropgene.*,javax.xml.parsers.*,org.w3c.dom.*,java.io.*,java.util.*,java.net.URLEncoder" %><%

org.apache.log4j.Logger LOG = org.apache.log4j.Logger.getLogger("fr.cirad.cmap");

String sModule = request.getParameter("module");
int numOnglet = Integer.parseInt(request.getParameter("numOnglet"));

String sModulePath = ModuleListManager.getModuleConfigPath(sModule) + java.io.File.separator;
ElementDocumentXml criteresXML = new ElementDocumentXml(sModulePath + "criteres.xml");

String sMapFeatureStartPosAliasForCMAP = null;
String sMapFeatureStopPosAliasForCMAP = null;
String sQtlNameAliasForCMAP = null;
String sMapLinkageGroupAliasForCMAP = null;
String sMapChromosomeAliasForCMAP = null;
HashMap<String, String> fieldNamesToAliases = new HashMap<String, String>();

String sCMapQueries = "";

for (int m = 0; m < criteresXML.racine.getElementsByTagName("onglet").getLength(); m++)
{
	if (numOnglet == m)
	{
		Element onglet = (Element)criteresXML.racine.getElementsByTagName("onglet").item(m);
		NodeList tableNodes = onglet.getElementsByTagName("table");
		// PARCOURIR TOUTES LES TABLES POUR RECUPERER TOUS LES CHAMPS RESULTATS //
		for (int n = 0; n < tableNodes.getLength(); n++){
			Element table = (Element)tableNodes.item(n);
			// LA TABLE //
			Element tab = (Element)table.getElementsByTagName("nom").item(0);
			String sTableName = tab.getTextContent();
			// RECUPERER L'ALIAS DE LA TABLE //
			String alias = tab.getAttribute("alias");
			// LISTE DES CHAMPS RESULTATS DE CETTE TABLE //
			NodeList champsResults = table.getElementsByTagName("champ_result");
			for (int o = 0; o < champsResults.getLength(); o++)
			{
				Element e = (Element)champsResults.item(o);
				fieldNamesToAliases.put(alias+"."+e.getTextContent(), e.getAttribute("nom_significatif"));
				if ("mapfeature".equals(sTableName) || "qtl".equals(sTableName) || "map".equals(sTableName))
				{
					if ("start_position".equals(e.getTextContent()))
						sMapFeatureStartPosAliasForCMAP = alias+"."+e.getTextContent();
					else if ("stop_position".equals(e.getTextContent()))
						sMapFeatureStopPosAliasForCMAP = alias+"."+e.getTextContent();
					else if ("qtl".equals(sTableName) && "name".equals(e.getTextContent()))
						sQtlNameAliasForCMAP = alias+"."+e.getTextContent();
					else if ("linkage_group".equals(e.getTextContent()) || ("map".equals(sTableName) && "name".equals(e.getTextContent())))
						sMapLinkageGroupAliasForCMAP = alias+"."+e.getTextContent();
					else if ("chromosome".equals(e.getTextContent()))
						sMapChromosomeAliasForCMAP = alias+"."+e.getTextContent();
				}
					
				LOG.debug("fieldNamesToAliases.put : " + alias+"."+e.getTextContent() + " , " + e.getAttribute("nom_significatif"));
			}
		}
		break;
	}
}

Properties env = new Properties();
env.put(javax.naming.Context.INITIAL_CONTEXT_FACTORY, "org.apache.naming.java.javaURLContextFactory");
env.put(javax.naming.Context.URL_PKG_PREFIXES, "org.apache.naming");
javax.naming.InitialContext ic = new javax.naming.InitialContext(env);
javax.naming.Context envCtx = (javax.naming.Context) ic.lookup("java:comp/env");
java.sql.Connection cmapConnection = null;

try
{
	cmapConnection = ((javax.sql.DataSource) envCtx.lookup("jdbc/cmap")).getConnection();
	
	String sType = request.getParameter("type"), sMainField = request.getParameter("mainField"), sFeatureName = null, sMapSetID = null, sAccID = null, sCmapUrl = null;

	// pour que les liens cmap de type map puissent fonctionner il faudrait affecter ici le marker ou qtl correspondant
	String sAttributeVal = request.getParameter(sMainField);
					
	Double startPos = null, stopPos = null;
	try
	{
		startPos = Double.valueOf(request.getParameter(fieldNamesToAliases.get(sMapFeatureStartPosAliasForCMAP)));
		stopPos = Double.valueOf(request.getParameter(fieldNamesToAliases.get(sMapFeatureStopPosAliasForCMAP)));
	}
	catch (NullPointerException ignored)
	{
		//ignored.printStackTrace();
	}
		
	String sLocationPrecisionBit = startPos != null && stopPos != null ? " and cmap_feature.feature_start = " + startPos + " and cmap_feature.feature_stop = " + stopPos : "";

	String sMainFieldAlias = null;
	for (String sKey : fieldNamesToAliases.keySet().toArray(new String[0]))
		if (sMainField.equals(fieldNamesToAliases.get(sKey)))
		{
			sMainFieldAlias = sKey;
			break;
		}
	
	if (sType.equalsIgnoreCase("qtl") && !"qtl.name".equals(sMainFieldAlias))
	{
		String sQtlPrecisionBit = "";
//		try
		{
			if (sQtlNameAliasForCMAP == null)
				LOG.warn("Afin de s'assurer de pouvoir proposer un lien CMAP pour chaque Trait dans QTL, il faut faire figurer la colonne qtl.name parmi les rsultats.");
			else											
				sQtlPrecisionBit = " and cmap_feature.feature_name='" + sAttributeVal.replaceAll(" ", "_") + "_" + request.getParameter(fieldNamesToAliases.get(sQtlNameAliasForCMAP)) + "'";
		}
/*		catch (SQLException sqle)
		{
			String sMsg = sqle.getMessage();
			if (sMsg.startsWith("Column ") && sMsg.endsWith(" not found."))
				LOG.warn("Afin de s'assurer de pouvoir proposer un lien CMAP pour chaque Trait dans QTL, il faut faire figurer la colonne qtl.name parmi les rsultats.");
			else
				throw sqle;
		}*/
		String sCMapQuery = "select distinct cmap_feature.feature_name from cmap_feature inner join cmap_attribute on cmap_feature.feature_id = cmap_attribute.object_id where (cmap_attribute.attribute_value = '" + sAttributeVal + "'" + sLocationPrecisionBit + sQtlPrecisionBit + ")";
		LOG.info("CMAP Query: " + sCMapQuery);
		sCMapQueries += sCMapQuery;
		java.sql.ResultSet feature = cmapConnection.createStatement().executeQuery(sCMapQuery);		

		feature.beforeFirst();
		if (feature.next())
			sFeatureName = feature.getString(1);
		if (feature.next())
			sFeatureName = null;	// il ne devrait y avoir qu'un enregistrement alors autant ne rien afficher que de prendre le risque que le lien soit faux
	}
	else
	{
		LOG.debug("Using main field value (" + sAttributeVal + ") as feature name.");
		sFeatureName = sAttributeVal;
	}
	
	if (sFeatureName != null)
	{
		String sLinkageGroup = null;
		try
		{
			sLinkageGroup = request.getParameter(fieldNamesToAliases.get(sMapLinkageGroupAliasForCMAP));
		}
		catch (Exception e)
		{
			try
			{
				sLinkageGroup = request.getParameter(fieldNamesToAliases.get(sMapChromosomeAliasForCMAP));
			}
			catch (Exception ignored)
			{
				ignored.printStackTrace();
			}
		}

		String sLinkageGroupBit = sLinkageGroup != null ? (" and cmap_map.map_name=?") : "";
		String sStudyNameAlias = fieldNamesToAliases.get("study.name");
		String sStudyFilter = sStudyNameAlias == null ? "" : " and concat('" + request.getParameter(sStudyNameAlias) + "_', cmap_map.map_name)=cmap_map.map_acc";
		String sCMapQuery = "SELECT DISTINCT map_set_id, feature_acc FROM cmap_map inner join cmap_feature on cmap_map.map_id = cmap_feature.map_id where (cmap_feature.feature_name=?" + sLocationPrecisionBit + sLinkageGroupBit + sStudyFilter + ")";
		String sLoggedCMapQuery = sCMapQuery.replaceFirst("\\?", "'" + sFeatureName + "'");
		java.sql.PreparedStatement ps = cmapConnection.prepareStatement(sCMapQuery);			
		ps.setObject(1, sFeatureName);										
		
		if (sLinkageGroup != null)
		{
			ps.setObject(2, sLinkageGroup);
			sLoggedCMapQuery = sLoggedCMapQuery.replaceFirst("\\?", "'" + sLinkageGroup + "'");
		}
		LOG.info("CMAP query : " + sLoggedCMapQuery);
		sCMapQueries += " ------------------------- " + sLoggedCMapQuery;
		java.sql.ResultSet ref_map_set_aids = ps.executeQuery();

		if (ref_map_set_aids.next())
		{
			sMapSetID = ref_map_set_aids.getString(1);
			sAccID = ref_map_set_aids.getString(2);
		}
		if (ref_map_set_aids.next())
		{	// il ne devrait y avoir qu'un enregistrement alors autant ne rien afficher que de prendre le risque que le lien soit faux
			sMapSetID = null;
			sAccID = null;
			LOG.warn("Several records found for query:" + sLoggedCMapQuery);
		}

		if (sMapSetID != null)
		{
			/*
			sCMapQuery = "SELECT DISTINCT feature_acc from cmap_feature" + (sLinkageGroup != null ? (" inner join cmap_map on cmap_map.map_id = cmap_feature.map_id") : "") + " where (feature_name=?" + sLocationPrecisionBit + sLinkageGroupBit + ")";
			ps = cmapConnection.prepareStatement(sCMapQuery);
			ps.setObject(1, sFeatureName);
			if (sLinkageGroup != null)
				ps.setObject(2, sLinkageGroup);
			
			ResultSet ref_map_aids = ps.executeQuery();
			if (ref_map_aids.next())
				sAccID = ref_map_aids.getString(1);
			if (ref_map_aids.next())
				sAccID = null;	// il ne devrait y avoir qu'un enregistrement alors autant ne rien afficher que de prendre le risque que le lien soit faux
			*/
			
			if (sAccID != null)
			{
				if (sType.equalsIgnoreCase("marker"))
				{
					int nElement = sAccID.lastIndexOf("_");
					sAccID = sAccID.substring(0, nElement);
				}
				else
				{
					int nElement = sAccID.lastIndexOf("_");
					sAccID =sAccID.substring(0, nElement);
 					int _element = sAccID.lastIndexOf("_");
 					sAccID = sAccID.substring(0,_element);
				}
				sCmapUrl = TextConstants.get("cmapUrl") + "ref_map_set_aid=" + URLEncoder.encode(sMapSetID, "UTF-8") + ";ref_map_aid=" + URLEncoder.encode(sAccID, "UTF-8") + ";highlight=" + URLEncoder.encode(sFeatureName, "UTF-8") + "&data_source=CMap";
			}
		}
	}

	if (/*sAttributeVal.contains("b") && */sCmapUrl != null)
	{	
		response.sendRedirect(sCmapUrl);
		return;
	}
}
catch (javax.naming.NamingException ne)
{
	throw new Exception("Unable to acquire connection from CMap connection pool under 'jdbc/cmap' : " + ne.getMessage());
}
finally
{
	if (cmapConnection != null)
		cmapConnection.close();
}

response.setStatus(HttpServletResponse.SC_NOT_FOUND, "true".equals(request.getParameter("debug")) ? sCMapQueries : "");
%>