<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" import="fr.cirad.tropgene.*,javax.xml.parsers.*,org.w3c.dom.*,java.io.*,java.util.*" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<link rel="stylesheet" type="text/css" href='../CSS/interface.css'/>
	<title><%= TextConstants.get("siteTitle") %></title>
	<link rel="shortcut icon" href="../images/favicon.ico">

	<style>
	<!--
	 h1
	 {
	 	font-size:20px;
	 	font-weight:bold;
	 	margin-bottom:40px;
	 }

	 h2
	 {
	 	font-size:16px;
	 	font-weight:bold;
	 	margin-bottom:20px;
	 }

	 img.guiDocImage
	 {
	 	border:3px outset #00956B;
	 	margin:0px 10px 5px 10px;
	 }
	 
	 p
	 {
	 	text-align:justify;
	 }
	-->
	</style>
</head>

<body>

<jsp:include page="topinc.jsp" flush="true"></jsp:include>
<jsp:include page="menu.jsp" flush="true"></jsp:include>

<br>

<center>
<div id="div6" align='center' style='padding:20px; width:800px; font-size:14px; border:1px dashed #000000; background-color:#f7f7f7;'>

<table width="94%" border="0" cellspacing="0" cellpadding="0" style='margin-top:10px;'>
	<tbody>
		<tr>
			<td>

<h1>TropGeneDB: user interface documentation</h1>

<table width='100%' cellspacing='0' cellpadding='0'>
 <tr>
  <td align="right">
  <p><img class='guiDocImage' src="../images/gui_doc/menu.jpg"></p>
  </td>
  <td valign='top'>
  <p>In order to consult data related to a given
  species, select it from the &quot;Species&quot; menu-item. You will end-up on
  a page containing one or several tabs, depending on the chosen crop. Each tab
  contains a different query form, that leads to different types of data.</p>
  </td>
  <td align="right">
  <p><img class='guiDocImage' src="../images/gui_doc/tabs.jpg"></p>
  </td>
 </tr>
</table>

<p>&nbsp;</p>

<h2>GENERALITIES ABOUT QUERY FORMS</h2>

<p>
<img class='guiDocImage' src="../images/gui_doc/form.jpg">
<br>
A query form consists of various kinds of filters
represented by standard input widgets. An important point is the ability to
select the operator (AND / OR) applied for grouping together the filters
defined by used widgets.
</p>


<table width='100%' cellspacing='0' cellpadding='5'>
 <tr>
  <td valign='top'>
  <p>The only situation where both operators can be
combined is when using multiple-choice list-boxes: all items selected within a
box of this type will implicitly be grouped together using the OR operator,
while the default AND operator, if it remains selected in the web form, can
still apply between choices made for each criterion.</p>
  </td>
  <td align="right">
  <p><img class='guiDocImage' src="../images/gui_doc/multiple_selection.jpg" width='400'></p>
  </td>
 </tr>
</table>

<p>&nbsp;</p>

<h2>QUERY FORM USAGE TIPS</h2>

<p>Some filters have peculiarities, users may want to know about:</p>

<table width='100%' cellspacing='0' cellpadding='0'>
 <tr>
  <td valign='top'>
  <p>- Some text-boxes have lookup-lists tied to
  them. This is particularly useful when a non-trivial, exact string is expected.</p>
  </td>
  <td align="right">
  <p><img class='guiDocImage' src="../images/gui_doc/lookup.jpg"></p>
  </td>
 </tr>
</table>

<p>- If you are unfamiliar with multiple-choice
list-boxes you may have trouble selecting most items: just click somewhere in
the box, then type CTRL / A to select all items, keep the CTRL key down and
finally unselect unwanted items by simple mouse-clicks.</p>

<p>- Filters where a red cross lies between the
criterion label and the widget can be removed by clicking on the mentioned
cross icon. Those filters can also be (re-)added, several times if needed,
using the &quot;Add criterion&quot; list-box. Having several identical filters
only makes sense when using the OR operator, because otherwise selecting two
different values for the same criterion would result in an empty dataset.</p>

<table width='100%' cellspacing='0' cellpadding='0'>
 <tr>
  <td valign='top'>
  <p>- Filters for which no red cross appears
  essentially consist of list-boxes whose contents are subject to a dependency
  relationship. This kind of relationship ties list-boxes two by two: the
  contents of the second one are automatically updated when selection changes in
  the first.</p>
  </td>
  <td align="right">
  <p><img class='guiDocImage' src="../images/gui_doc/dependency.jpg"></p>
  </td>
 </tr>
</table>

<p>&nbsp;</p>

<h2>ABOUT RESULT DATA</h2>

<p>
<img class='guiDocImage' src="../images/gui_doc/results.jpg">
<br>
Search results are displayed in tables where
each column represents a relevant attribute (database field). Visualised data
can be sorted by any of those fields by clicking on the column header label.</p>


<table width='100%' cellspacing='0' cellpadding='0' border='0'>
 <tr>
  <td align="left" valign='top'>
  <p><img class='guiDocImage' src="../images/gui_doc/cmap_link.jpg"></p>
  </td>
  <td valign='top'>
  <p>In cases where additional details are available regarding an attribute,
	its value is highlighted in orange: when moused over, an extra layer
	appears where one or more links can be clicked.</p>
  </td>
  <td align="left" rowspan="2">
  <p><img class='guiDocImage' src="../images/gui_doc/cmap.jpg" style='margin-bottom:0px;'></p>
  </td>
 </tr>
 <tr>
  <td colspan="2">
  	Apart from "detaid sheets" which are internal TropgeneDB pages, such links can also lead to comparative map views (CMAP), or to a downloadable file (typically providing a full genotyping study's data when it is too large to be searched in).
  	<p>&nbsp;</p>
  </td>
 </tr>
</table>

<p>
<br>
<img class='guiDocImage' src="../images/gui_doc/pagination.jpg">
<br>Pagination is used for displaying the
results. Apart from being able to move to the first, next, previous or last
page, you can also define the number of records per page, or directly jump to a
page by specifying its index.</p>

<p>&nbsp;</p>

<h2>EXPORTING RESULTS</h2>

<table width='100%' cellspacing='0' cellpadding='0'>
 <tr>
  <td valign='top'>
  <p>At the end of the navigation bar can be found
	an &quot;Export results&quot; list box that lets you select an export format:
	Excel or Text (csv). Depending on the kind of data that is being dealt with, 2
	extra formats may be offered: Excel matrix and Text matrix. Simply select an
	output format then click the button next to this box, and data download will
	start.</p>
  </td>
  <td align="right">
  <p><img class='guiDocImage' src="../images/gui_doc/export.jpg"></p>
  </td>
 </tr>
</table>

</div>

</div>
</center>

<br>

</body>
</html>