<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" import="fr.cirad.tropgene.*,javax.xml.parsers.*,org.w3c.dom.*,java.io.*,java.util.*" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<link rel="stylesheet" type="text/css" href='../CSS/interface.css'/>
	<title><%= TextConstants.get("siteTitle") %></title>
	<link rel="shortcut icon" href="../images/favicon.ico">
</head>

<body>

<jsp:include page="topinc.jsp" flush="true"></jsp:include>
<jsp:include page="menu.jsp" flush="true"></jsp:include>

<br>

<center>
<div id="div6" align='center' style='padding:20px; width:800px; font-size:14px; border:1px dashed #000000; background-color:#f7f7f7;'>

<table width="90%" border="0" cellspacing="0" cellpadding="0" style='margin-top:10px;'>
	<tbody>
		<tr>
			<td>
<div class="texte" align="center" style='font-size:18px'><b>TropGeneDB: an information system for tropical and Mediterranean crops</b></div><br>

<p>
    TropGeneDB is an information system initially developed by CIRAD (Agricultural research for development) to manage various kinds of data on tropical and
    Mediterranean plants. It is a Web application based on MySQL databases (one per crop) that can be queried using Java customizable interfaces automatically
    generated to fit the databases contents.
</p>
<p>
    TropGeneDB can record crop information on:
    <br/>
    - molecular markers, QTLs, genetic and physical maps
    <br/>
    - genetic diversity, association and linkage disequilibrium studies
    <br/>
    - phenotypic diversity studies based on agro-morphological traits or traits measuring the susceptibility/resistance to aggression (diseases, salinity,
    drought)
    <br/>
    - geographic origin, parentage, collection, ecology
</p>
<p>
    The TropGeneDB project <strong>[1]</strong> was initiated by P. Lagoda and L.M. Raboin in 1996 using the DBMS ACEDB but the databases were later migrated
    to the MySQL DBMS in order to follow the evolution of the computer technology.
</p>
<p>
    Data on the following 10 crops are currently recorded in TropGeneDB: banana, cocoa, <a name="_GoBack"></a>coconut, coffee, cotton, oil palm, rice, rubber
    tree, sorghum, sugarcane. Data on new plants (alfalfa, grapevine, tomato, millet and einkorn) will be soon added to the system.
    <br/>
    <br/>
    All the data in TropGeneDB are public and have already been published in scientific papers.
    <br/>
    <br/>
    People wishing to submit data may download <a href="http://dombes.cirad.fr:8080/tropgene/downloads/submission_files.zip">submission templates</a> which
    consist of Microsoft Excel files. <a href="http://dombes.cirad.fr:8080/tropgene/downloads/tropgene_data_submission.pdf">See instructions</a> for filling
in the templates which should then be sent to <a href='iFrameInIbox.jsp?url=<%= java.net.URLEncoder.encode(TextConstants.get("contactFormURL")) %>' rel='ibox&height=350'>TropgeneDB</a>   
    <br/>
</p>
<p>
    <strong>[1]</strong>
    <a>Ruiz M, Rouard M, Raboin LM, Lartaud M, Lagoda P, Courtois B., (2004) TropGENE-DB, a multi-tropical crop information system, Nucleic Acids Res. </a>
    Jan 1;32(1):D364-7.
</p>
<br/>
<p>
    Contact:
<a href='iFrameInIbox.jsp?url=<%= java.net.URLEncoder.encode(TextConstants.get("contactFormURL")) %>' rel='ibox&height=350'>TropgeneDB</a>
</p>

			</td>
		</tr>
	</tbody>
</table>

</div>    
</center>

<br>

</body>
</html>
